using System;
using jp.netgamers.free.tuogl;	//	OpenGL ̔bp[ڎwĂ
using jp.netgamers.free.tugame;	//	OpenGL ̃CuڎwĂ

class MyPrimitive
{
	public short[]	va;
	public uint[]	ca;

	public MyPrimitive( String path )
	{
		va = TUAssets.readTSVArray<short>( path + "/vertex.tsv" );
		ca = TUAssets.readTSVArray<uint>( path + "/color.tsv" );
	}

	public void draw( float x, float y, float z )
	{
		GL1.VertexPointer( 3, va );	//	_W̐ݒ
		GL1.ColorPointer(			//	F̐ݒ
		 4,							//	F̗vf
		 GL1._UNSIGNED_BYTE,		//	f[^̌^
		 0,							//	f[^Ԋu
		 ca );						//	Ff[^

		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Translatef( x, y, z );	//	sړ
		GL1.DrawArrays(				//	z`
		 GL1._TRIANGLES,			//	Op`̕`
		 0,							//	Jnʒu
		 va.Length / 3 );			//	_
		GL1.PopMatrix();			//	}gbNXX^bNo
	}

}

class ETrain : TURetroGame
{
	static float		PX;		//	vC[̍W
	static int[]		Map = new int[ 32 * 32 ];
	static int			Score;		//	_

	public override void wmCreated()
	{
		Title = "Edɏ낤";

		for( int i = 0; i < 30; i++ ){
			Map[ rnd( 32 ) * 32 + rnd( 32 ) ] = 1;
		}

		for( int i = 0; i < 200; i++ ){
			Map[ rnd( 32 ) * 32 + rnd( 32 ) ] = 2;
		}

		for( int i = 0; i < 50; i++ ){
			Map[ rnd( 32 ) * 32 + rnd( 32 ) ] = 3;
		}
Map[ 16 * 32 + 16 ] = 3;

		setFrameRate( 60 );
	}

	public override void wmTimer()
	{
		Score++;
		PX += 2;
		Invalidate();	//	ĕ`˗
	}

	public override void onKeyDown( int code )
	{
	}

	public override void onKeyUp( int code )
	{
	}

	public override void wmDraw()
	{

		MyPrimitive	building = new MyPrimitive( "Building" );	//	
		MyPrimitive	hatake   = new MyPrimitive( "Hatake" );		//	
		MyPrimitive	house    = new MyPrimitive( "House" );		//	
		MyPrimitive	rail     = new MyPrimitive( "Rail" );		//	[
		MyPrimitive	train    = new MyPrimitive( "Train" );		//	

		GL1.ClearColor( 0xffcccc77 );	//	ʃNA̐Fw
		GL1.Clear(					//	ʃNA
		 GL1._DEPTH_BUFFER_BIT |	//	[xobt@
		 GL1._COLOR_BUFFER_BIT );	//	Fobt@
		GL1.LoadIdentity();			//	ftHg̃}gbNXǂݍ
		GL1.Scale( 0.0453f );		//	XP[ύXBglScalef( 0.0453f, 0.0453f, 0.0453f );
		GL1.LookAt(					//	_ݒ
		  -1,  -1,  0.817f,			//	J̈ʒu
		   0,   0,  0,				//	Jʂ̒
		   0,   0,  1 );			//	J̌

		GL1.Enable( GL1._DEPTH_TEST );	//	[xeXgL
		GL1.EnableClientState( GL1._COLOR_ARRAY );	//	FzL

		//	[`
		GL1.PushMatrix();			//	}gbNXX^bNɊi[
		GL1.Scalef( 100, 1, 1 );	//	XP[ύX
		rail.draw( 0, -11, 0 );
		rail.draw( 0,  11, 0 );
		GL1.PopMatrix();			//	}gbNXX^bNo


		//	`
		for( int i = 0; i < Map.Length; i++ ){
			if( Map[ i ] == 1 ){
				building.draw( ( i % 32 - 16 ) * 100, ( i / 32 - 16 ) * 100, 0 );
			}
			if( Map[ i ] == 2 ){
				hatake.draw( ( i % 32 - 16 ) * 100, ( i / 32 - 16 ) * 100, 0 );
			}
			if( Map[ i ] == 3 ){
				house.draw( ( i % 32 - 16 ) * 100, ( i / 32 - 16 ) * 100, 0 );
			}
		}

		//	Ԃ`
		for( int i = 0; i < 12; i++ ){
			train.draw( PX - i * 100, 0, 0 );
		}

		GL1.DisableClientState( GL1._COLOR_ARRAY );	//	Fz𖳌
		GL1.Disable( GL1._DEPTH_TEST );
		GL1.LoadIdentity();				//	ftHg̃}gbNXǂݍ
		draw( "SCORE " + Score );
	}

	static void Main()
	{
		new ETrain();
	}
}
